import threading
import time
import random
import sys

MAX_CUST = 20
MAX_SOFA = 4
MAX_BARBER = 3
MAX_OVERALL = 50

max_cust = threading.Semaphore(MAX_CUST)
sofa = threading.Semaphore(MAX_SOFA)
chair = threading.Semaphore(MAX_BARBER)
coord = threading.Semaphore(MAX_BARBER)
leave_chair = threading.Semaphore(0)
ready = threading.Semaphore(0)
payment = threading.Semaphore(0)
receipt = threading.Semaphore(0)
finish = [threading.Semaphore(0) for i in range(MAX_OVERALL)]
mutex = [threading.Semaphore(1), threading.Semaphore(1)]
queue = []
count = 0
terminate = False

def exit_barber():
    return not(terminate)

def exit_cashier():
    return exit_barber()

def action(actor, i, action):
    print("Il %s %d fa l'azione %s" %(actor, i, action))
    sys.stdout.flush()
    time.sleep(random.randint(1, 10))

def customer(i):
    global queue
    global count
    max_cust.acquire()
    action("cliente", i, "enter_shop")
    mutex[0].acquire()
    cust_nr = count
    count += 1
    print("Il cliente %d ha il numero %d" %(i, cust_nr))
    sys.stdout.flush()
    mutex[0].release()
    sofa.acquire()
    action("cliente", i, "sit_on_sofa")
    chair.acquire()
    action("cliente", i, "get_up_from_sofa")
    sofa.release()
    action("cliente", i, "sit_on_chair")
    mutex[1].acquire()
    queue += [cust_nr]
    mutex[1].release()
    ready.release()
    finish[cust_nr].acquire()
    action("cliente", i, "leave_chair")
    leave_chair.release()
    action("cliente", i, "pay")
    payment.release()
    receipt.acquire()
    action("cliente", i, "exit_shop")
    max_cust.release()

def barber(i):
    global queue
    while exit_barber():
        ready.acquire()
        if terminate:
            return
        mutex[1].acquire()
        b_cust = queue.pop(0)
        mutex[1].release()
        coord.acquire()
        action("barbiere", i, "cut_hair a %d" %b_cust)
        coord.release()
        finish[b_cust].release()
        action("barbiere", i, "done_cut_hair a %d" %b_cust)
        leave_chair.acquire()
        chair.release()

def cashier(i):
    while exit_cashier():
        payment.acquire()
        if terminate:
            return
        coord.acquire()
        action("cassiere", i, "accept_pay")
        coord.release()
        receipt.release()

tests = []
tests += [[(0, i) for i in range(5)]]

for i in range(len(tests)):
    t = []
    bc = []
    for j in range(MAX_BARBER):
        bc += [threading.Thread(target=(barber), args=[j])]
        bc[-1].start()
    bc += [threading.Thread(target=(cashier), args=[0])]
    bc[-1].start()
    for j in range(len(tests[i])):
        test = tests[i][j]
        time.sleep(test[0])
        t += [threading.Thread(target=(customer), args=[test[1]])]
        t[-1].start()
    for j in range(len(tests[i])):
        t[j].join()
        print("joined cliente %d" %j)
        sys.stdout.flush()
    terminate = True
    payment.release()
    for j in range(MAX_BARBER):
        ready.release()
    for j in range(MAX_BARBER + 1):
        bc[j].join()
        print("joined barbiere/cassiere %d" %j)
        sys.stdout.flush()
    print("test %d finished!" %i)
    sys.stdout.flush()
    
