import threading
import time
import random
import sys

MAX_CUST = 20
MAX_SOFA = 4
MAX_BARBER = 3

max_cust = threading.Semaphore(MAX_CUST)
sofa = threading.Semaphore(MAX_SOFA)
chair = threading.Semaphore(0)
ready = threading.Semaphore(0)
payment = threading.Semaphore(0)
receipt = threading.Semaphore(0)
finish = [threading.Semaphore(0) for i in range(MAX_BARBER)]
mutex = threading.Semaphore(1)
next_barber = 0
terminate = False

def exit_barber():
    return not(terminate)

def exit_cashier():
    return exit_barber()

def action(actor, i, action):
    print("Il %s %d fa l'azione %s" %(actor, i, action))
    sys.stdout.flush()
    time.sleep(random.randint(1, 10))

def customer(i):
    global next_barber
    max_cust.acquire()
    action("cliente", i, "enter_shop")
    sofa.acquire()
    action("cliente", i, "sit_on_sofa")
    chair.acquire()
    action("cliente", i, "get_up_from_sofa")
    sofa.release()
    my_barber = next_barber
    action("cliente", i, "sit_on_chair of barber %d" %my_barber)
    ready.release()
    finish[my_barber].acquire()
    action("cliente", i, "leave_chair_and_pay")
    payment.release()
    receipt.acquire()
    action("cliente", i, "exit_shop")
    max_cust.release()

def barber(i):
    global next_barber
    while exit_barber():
        mutex.acquire()
        next_barber = i
        chair.release()
        ready.acquire()
        if terminate:
            mutex.release()
            return
        mutex.release()
        action("barbiere", i, "cut_hair")
        finish[i].release()
        action("barbiere", i, "done_cut_hair")
        payment.acquire()
        action("barbiere", i, "accept_pay")
        receipt.release()

tests = []
tests += [[(0, i) for i in range(5)]]

for i in range(len(tests)):
    t = []
    bc = []
    for j in range(MAX_BARBER):
        bc += [threading.Thread(target=(barber), args=[j])]
        bc[-1].start()
    for j in range(len(tests[i])):
        test = tests[i][j]
        time.sleep(test[0])
        t += [threading.Thread(target=(customer), args=[test[1]])]
        t[-1].start()
    for j in range(len(tests[i])):
        t[j].join()
        print("joined cliente %d" %j)
        sys.stdout.flush()
    terminate = True
    for j in range(MAX_BARBER):
        ready.release()
    for j in range(MAX_BARBER):
        bc[j].join()
        print("joined barbiere %d" %j)
        sys.stdout.flush()
    print("test %d finished!" %i)
    sys.stdout.flush()
    
