import threading
import time
import random

DIM = 5
s = threading.Semaphore(1)
n = threading.Semaphore(0)
e = threading.Semaphore(DIM - 1)

class Buffer:
    def __init__(self, dim):
        self.b = [0 for i in range(dim)]
        self.point_in = 0
        self.point_out = 0
        self.dim = dim

    def append(self, v):
        if (self.point_in + 1)%self.dim == self.point_out:
            raise Exception("Internal error: append should never be called when the buffer is full")
        self.b[self.point_in] = v
        self.point_in = (self.point_in + 1)%self.dim

    def take(self):
        if self.point_in == self.point_out:
            raise Exception("Internal error: take should never be called when the buffer is empty")
        v = self.b[self.point_out]
        self.point_out = (self.point_out + 1)%self.dim
        return v
        
def produce():
    time.sleep(1)
    return random.randint(1, 10)

def consume(v):
    time.sleep(1)

def producer(i):
    global b
    v = produce()
    e.acquire()
    s.acquire()
    print("Il produttore %d e' nella sezione critica" %(i))
    b.append(v)
    s.release()
    n.release()

def consumer(i):
    global b
    n.acquire()
    s.acquire()
    print("Il consumatore %d e' nella sezione critica" %(i))
    v = b.take()
    s.release()
    e.release()
    consume(v)

tests = []
tests += [[(0, producer if i%2 == 0 else consumer, i) for i in range(50)]]

for i in range(len(tests)):
    t = []
    b = Buffer(DIM)
    for j in range(len(tests[i])):
        test = tests[i][j]
        time.sleep(test[0])
        t += [threading.Thread(target=(test[1]), args=[test[2]])]
        t[-1].start()
    for j in range(len(tests[i])):
        t[j].join()
    print("test %d finished!" %i)
